/**
 * [getShoppingCar_control 获取购物车数据处理]
 * @param  {Object} data [处理数据]
 */
function getShoppingCar_control(data) {
	J.Cache.save('shoppingCarData', data);
	J.Cache.save('editArray', []);
	J.Template.render("#shoppingCar_article", "shoppingCar_template", data, "replace");
	$('#shoppingCart_article .p_carN').trigger('click');
}
/**
 * [countTotal_control 计算价格和数量]
 * @param  {Object} elements [当前元素]
 * @param  {String} handleType  [点击类型 'one'单体 'all'全选 'some'一系列商品]
 */
function countTotal_control(elements, handleType) {
	var totalMoney = 0,
		totalNum = 0,
		isAllOn = true;

	$(elements).toggleActive();

	if(handleType == 'one') {
		var isSomeOn = true;
		var ele = elements.parentElement.parentElement.querySelector('.car_title');
		var eleLi = elements.parentElement.parentElement.querySelectorAll('label[data-name=radio]');
		for(var i = 0; i < eleLi.length; i++) {
			isSomeOn = isSomeOn && $(eleLi[i]).hasClass('active');
		}
		isSomeOn ? $(ele).addClass('active') : $(ele).removeClass('active');
	}
	$("#shoppingCar_article li").each(function() {
		var el = $(this).find('label[data-name=radio]');
		if (handleType == 'all'){
			$(elements).hasClass('active') ? el.addClass('active') : el.removeClass('active');
			this.parentElement.querySelector('.car_title').className =  $(elements).hasClass('active') ? 'car_title active' : 'car_title'
		}else if (handleType == 'one'){
			$("#totalChecked").removeClass('active');
		}else if (handleType == 'some'){
			$(elements).hasClass('active') ? $(elements).parent().find('label[data-name=radio]').addClass('active') : $(elements).parent().find('label[data-name=radio]').removeClass('active');
			$("#totalChecked").removeClass('active');
		}
		if (el.hasClass('active')) {
			var num = parseInt(el.attr('data-num')),
				price = el.attr('data-price');
			totalMoney += price * num;
			totalNum += num;
		}
		isAllOn = isAllOn && el.hasClass('active');
	})
		isAllOn ? $("#totalChecked").addClass('active') : $("#totalChecked").removeClass('active');
	$("#totalNum").text(totalNum);
	$("#totalMoney").text(totalMoney.toFixed(2));
}

/**
 * [deleteEvents_control 删除购物车选中商品]
 */
function deleteEvents_control() {
	var deleteArr = [];
	$("#shoppingCar_article li").each(function() {
		if ($(this).find('label[data-name=radio]').hasClass('active')) deleteArr.push(parseInt($(this).val()));
	})
	deleteArr.length != 0 ? J.dialogbox('确认将这些宝贝删除?', function() {
		console.log(deleteArr);
		deleteShoppingCar_service(deleteArr);
	}) : J.showToast('您还没有选择宝贝哦');
}

/**
 * [editShopCar_control 编辑购物车]
 * @param  {Object} elements   [当前元素]
 * @param  {String} handleType [操作类型  'edit'编辑 'finish'完成]
 */
function editShopCar_control(elements, handleType) {
	$(elements).parent().hide().siblings('nav.right').show();
	var fn = {
		edit: function() {
			$("#shoppingCar_article div.right.edit").show().siblings("div.right").hide();
			$("#payMoney").hide().siblings(".sub-btn").show();
		},
		finish: function() {
			$("#shoppingCar_article div.right.edit").hide().siblings("div.right").show();
			$("#payMoney").show().siblings(".sub-btn").hide();
			if(!J.Cache.get('login')) {
				console.log('------')
				getOfflineShoppingCar_service();
			} else {				
				getShoppingCar_service();
			}
			
		},
		clearData: function() {
			$("#shoppingCar_article").find('label[data-name=radio]').removeClass('active');
			$("#shoppingCar_article .car_title").removeClass('active');
			$("#totalChecked").removeClass('active');
			$("#totalNum").text("0");
			$("#totalMoney").text("0.00");
		}
	}
	fn[handleType]();
	fn.clearData();
}

/**
 * [editShopCarNum_control 编辑购物车商品数量]
 * @param  {String} handleType  [编辑类型  'mulNum'减 'addNum'加 不存在该参数则为手动输入]
 * @param  {Number} num      [现在数量]
 * @param  {Object} elements [当前元素]
 * @param  {Number} id       [编辑商品id]
 */
function editShopCarNum_control(id, num, elements,handleType,canBuyNumber,stockNum,beginBuyNum) {
	if(handleType) eidtNum(handleType, num, elements,canBuyNumber,stockNum,beginBuyNum);
	var newNum = handleType ? parseInt($(elements).siblings('input').val()) : $(elements).val();
	// 手动输入时判断
	if(!handleType){
		var msg = /^[0-9]*$/;
		if(msg.test(newNum)){
			if(newNum <= 0){
				J.showToast('数量至少为1~~');
				return;
			}
		}else{
			J.showToast('请输入数字');
			$(elements).val(1);
			return;
		}
	}
	var editArray = [];
	var obj = {
		shoppingCarId: id,
		num: parseInt(newNum)
	};
	var handle = {
		success : function(){},
		error : function(data){
			var msg = (isNullString(data.message)) ? error_message : data.message;
			J.showToast(msg);
			handleType ? $(elements).siblings('input').val(num) : $(elements).val(num);
		}
	};
	editArray.push(obj);	
	editShoppingCar_service(editArray, handle);
}

/**
 * [shopCarPopup_control 编辑购物车颜色和型号]
 * @param  {Number} shopCarId [当前编辑ID]
 */
function shopCarPopup_control(shopCarId) {
	var data = J.Cache.get('shoppingCarData').data;
	var html = '';
	for (var k in data) {
		data[k].value.map(function(item) {
			if (item.id == shopCarId) {
				html = createPopupHtml(item.serviceEvent,'shopCarEventInfo'); //生成弹出框html
			}
		})
	}
	html += '</ul>';
	J.Popup.bottomsheet({
		html: html,
		buttons: [{
			text : '确定',
			class: 'brick-red',
			handler: function(){
				specificationPopup_control(shopCarId,'shopCarEventInfo');
			}
		}]
	});
}

/**
 * [editSpecification_control 编辑购物车规格]
 * @param  {Number} cartId [购物车id]
 * @param  {String} size   [size]
 * @param  {String} color  [color]
 */
function editSpecification_control(cartId, size, color) {
	var editArray = [];
	var obj = {
		shoppingCarId: cartId,
		size: size,
		color: color
	}
	editArray.push(obj);	
	var handle = {
		success: function() {
			$("#shoppingCar_article span[data-name='specification']").map(function(index, el) {
				if ($(el).attr('data-id') == cartId) $(el).text('规格:' + obj.color + ' ' + obj.size);
			})
		},
		error: function(data, xhr) {
			service.error(xhr, data);
		}
	}
	editShoppingCar_service(editArray, handle);
}

function selectTime(ele) {
	pay.par.deliveryTId = ele.value;
	if(ele.value) {		
		pay.par.deliveryTime = $(ele).find("option:selected").text();
	} else {
		pay.par.deliveryTime = '';
	}
	getSelectedShoppingCar_service(pay.par, 2);
}

function selectPickUpGoods(type, ele) {
	pay.param.disType = type;
	$(ele).addClass('active').siblings().removeClass('active');
}

// 未登录将商品加入购物车
function saveOfflineShopCar(shopCarId) {
	console.log(shopCarId);
	var arr = [];
	if(!J.Cache.get('offlineShopCar')) {
		arr.push(shopCarId);
	} else {
		arr = J.Cache.get('offlineShopCar').data;
		arr.push(shopCarId);
	}
	J.Cache.save('offlineShopCar', arr);
}

