/**
 * [getServiceEventDetails_service 获取商品详情service]
 * @param  {Number} eventId [商品id]
 */
function getServiceEventDetails_service(eventId, isRendering, perfId) {
    $('#productList_section header').attr('data-clearScroll', true); //商品列表页hide时不清滚动条
    //  J.showMask();
    var url = 'ws/serviceAction' + versionMessage.version + '!getServiceEventDetails.sy';
    var par = {
        serviceEventId: eventId,
        communityId: J.Cache.get('community').data.id
    };
    if(perfId) {
    	par.perfId = perfId
    }
    J.Cache.save('detailEventId', eventId);
    service.get(url, par, function (data) {
        if (data.brandClass) {
            data.brandClass.picture = picNetworkPrefix(data.brandClass.picture);
        }
        getRelateServiceEvent_service(eventId, data, 2); //获取关联商品
        if (data.description) {
            data.description = data.description.replace(/&amp;nbsp;/g, '&nbsp;').replace(/&lt;/g, '<').replace(/&gt;/g, '>')
                .replace(new RegExp("&amp;lt;br/&amp;gt;", "gm"), "<br/>")
        }
        if (!isNullString(data.picture)) data.picture = picNetworkPrefix(data.picture);
        // 轮播图
        if (!isNullString(data.carouselPicture)) {
            var carouselList = [];
            data.carouselPicture = data.carouselPicture.split(',');
            data.carouselPicture.map(function (item, index) {
                var data = {
                    url: picNetworkPrefix(item),
                };
                carouselList.push(data);
            })
            carouselList[0].hasActive = true;
            data.carouselPicture = carouselList;
        } else {
            var carouselData = {
                url: data.picture,
                hasActive: true
            }
            data.carouselPicture = [];
            data.carouselPicture.push(carouselData);
        }
        // 标签
		if(!isNullString(data.detailTag)) {
			data.detailTag = data.detailTag.split(',');
		}
        var specification = [];
        if (data.colorName) {
            var obj = {
                name: data.colorName,
                val: data.color.split(","),
                key: 'colorName'
            };
            specification.push(obj);
        }
        if (data.sizeName) {
            var obj = {
                name: data.sizeName,
                val: data.size.split(","),
                key: 'sizeName'
            };
            specification.push(obj);
        }
        J.Cache.save('beginBuyNum', {id:data.id, beginBuyNum: data.beginBuyNum});
        data.specification = specification;
        data.serviceLastTime = data.serviceLastTime ? data.serviceLastTime : 0;
        if(data.description){
            if (data.description.split('<img').length >= 2) {
                var mock = $(data.description);
                var _item = "";
                if (mock.find("img").length != 0) {
                    mock.find("img").map(function (ele, e) {
                        $(e).attr('src', picNetworkPrefix($(e).attr('src')));
                    });
                    $.each(mock, function (index, item) {
                        _item = _item + $(item).prop("outerHTML");
                    });
                    data.description = _item;
                }
            }
            if (data.description.indexOf('&nbsp;') >= 0) {
                data.description.replace(/&nbsp;/g, ' ');
            }
        }
        var shareData = {
            title: data.name,
            imgUrl: data.picture,
            eventId: eventId,
            type: data.type
        };
        J.Cache.save('share', shareData);
        getProductDetail_control(data, isRendering);
        J.hideMask();
    },function(data){
        if(data){
            J.showToast(data.message);
        }
    });
    if( J.Cache.get('login')){
        var url1 = 'ws/userBigDataAction!saveUserBigData.sy';
        var par = {
            type : 0,
            serviceEventId : eventId
        };
        service.get(url1, par, function (data){

        });
    }
}

// 获取关联商品
function getRelateServiceEvent_service(eventId, mock, place, orderMainId) {
    var url = 'ws/serviceAction' + versionMessage.version + '!getRelateServiceEvent.sy';
    var par = {
        serviceEventId: eventId,
        place: place
    }
    if(orderMainId) {
    	par.orderMainId = orderMainId;
    }
    if (par.place == 0) {
        service.get(url, par, function (data) {
        	if(data) {
	            data.map(function (item) {
	                if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
	            });
        	} else {
        		data = {};
        	}
        	J.Template.render("#orderDetailRelate_div", "orderDetailRelate_template", data, "replace");
        });
    } else if (par.place == 3) {
        service.get(url, par, function (data) {
            if(data) {
                data.map(function (item) {
                    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
                });
            } else {
                data = {};
            }
            if(data && data.length > 0){
                J.Template.render("#shoppingCartLikesRelate_div", "shoppingCartLikes_template", data, "replace");
            }else{
                $('#shoppingCartLikesRelate_div').empty();
            }
        });
    }else {
        service.get(url, par, function (data) {
        	if(data) {
        		data.map(function (item) {
        		    if (!isNullString(item.picture)) item.picture = picNetworkPrefix(item.picture);
        		});
        		if (data.length != 0) {
        		    var gos = (mock.type == 1) ? 'serviceDetail' : 'productDetail';
        		    J.Template.render("#" + gos + "Relate_div", gos + "Relate_template", data, "replace");
        		}
        	}
        })
    }

}
//邑豆订单详情内不跳转商品详情merchantId：18----邑豆兑换
function toServiceEventDetails(eventId,merchantId){
    if(merchantId != 18){
        getServiceEventDetails_service(eventId);
    }
}
//获取评论列表，type,1,专家意见,2,用户意见
function commentList_service(eventId, type) {
    J.showMask();
    $('.com .prof').removeClass('active');
    $('.com .user').removeClass('active');
    var par = {
        serviceEventId: eventId,
        type: type
    };
    var url = 'ws/commentAction' + versionMessage.version + '!goCommentListPage.sy';
    service.get(url, par, function (data) {
        J.hideMask();
        if (type == 1) {
            $('.com .prof').addClass('active');
            $('#professor').show();
        } else {
            $('.com .user').addClass('active');
            $('#professor').hide();
        }
        if (data.length != 0) {
            data.commentInfos.map(function (item) {
                if(item.picture) {
                    var pictures = item.picture.split(',');
                    for(var i = 0; i < pictures.length; i++) {
                        pictures[i] = fileServerUrl + pictures[i];
                    }
                }
                item.picture = pictures;
                item.photo = fileServerUrl  + item.photo;
                if(item.name.length >= 11){
                    item.name = item.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                }
                for(i in item.userParentCommentBeanList){
                    if(item.userParentCommentBeanList[i].userName.length >= 11){
                        item.userParentCommentBeanList[i].userName = item.userParentCommentBeanList[i].userName.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                    }
                }
            });
            J.Cache.save('commentInfo', data);
            J.Template.render("#commentNum_h1", "commentNum_template", data, "replace");
            J.Template.render("#score_div", "score_template", data, "replace");
            J.Template.render("#commentList_ul", "commentList_template", data, "replace");
            if(data.eventScore > 0){
                $('#score_div #over1')[0].style.width = data.eventScore * 4 + 'vw';
            }
            if(data.categoryRefScore > 0){
                $('#score_div #over2')[0].style.width = data.categoryRefScore * 4 + 'vw';
            }
            if (data.commentInfos.length == 0) {
                $('#kongPingJia').css('display', 'block');
            }
        } else {
            J.showToast('请求错误，请重试');
        }
    })
}
// 获取评论详情
function commentDetail_service(id,Type) {
    J.showMask();
    var url = 'ws/commentAction' + versionMessage.version + '!findUserComment.sy';
    var par = {
        commentId : id,
        type : Type
    };
    setTimeout(function(){
        J.Router.goTo("#commentDetail_section");
    },100);
    service.get(url, par, function (data) {
        var data1 = data[0];
        data1.userParentCommentBeanList = data[1];
        J.Cache.save('professionalComment', data1);
        if(data1.name.length >= 11){
            data1.name = data1.name.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
        }
        if(data1.picture) {
            var pictures = data1.picture.split(',');
            for(var i = 0; i < pictures.length; i++) {
                pictures[i] = fileServerUrl + pictures[i];
            }
        }
        data1.picture = pictures;
        data1.photo = fileServerUrl  + data1.photo;
        if (data1.userParentCommentBeanList.length != 0) {
            data1.userParentCommentBeanList.map(function(item){
                if(item.userName.length >= 11){
                    item.userName = item.userName.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
                    item.userAvator = picNetworkPrefix(item.userAvator);
                }
            });
        }
        J.Template.render("#commentDetail_article", "commentDetail_template", data1, "replace");
        $('#secondPingJia').data().commenteventid = data1.commentEventId;
        if(data1.type == 2){
            $('#commentFooter').css('display','none');
        }else if(data1.type == 1){
            $('#commentFooter').css('display','block');
        }
        J.hideMask();
    });
    //J.Cache.save('commentItem', item);
}
//评论详情展开全部/收起
function showAll(type){
    if(type){
        $('#desc').css('height','auto');
        $('#commentDetail_article .showAll').css('display','none');
        $('#commentDetail_article .hideAll').css('display','inline-block');
    }else{
        $('#desc').css('height','15vw');
        $('#commentDetail_article .showAll').css('display','inline-block');
        $('#commentDetail_article .hideAll').css('display','none');
    }
}

//提交评价
/**commentId  评价的id
 * commentText  评价内容
 * typeId  专家评价1 用户评价2
 * userId  用户id
 * */
function submitEvaluate_service(id){
    J.showMask();
    if($.trim($('#secondPingJia textarea').val())){
        var par = {
            commentId : id,
            commentText : $.trim($('#secondPingJia textarea').val()),
            typeId : 1,
            userId : J.Cache.get('login').data.id
        };
        var url = 'ws/commentAction' + versionMessage.version + '!saveUserComment.sy';
        service.get(url, par, function (data) {
            $('#secondPingJia textarea').val('');
            commentDetail_service(id,1);
            J.showToast('提交成功啦');
            J.hideMask();
        })
    }else{
        J.showToast('不能为空哦');
    }
}
//点赞
function thumbsUp_service(id,type,ele){
    var par = {
        commentId : id,
        typeId : type,
        userId : J.Cache.get('login').data.id
    };
    var url = 'ws/commentAction' + versionMessage.version + '!saveUserThumbup.sy';
    service.get(url, par, function (data) {
        J.showToast('点赞成功啦');
        $(ele).addClass('active');
        $(ele.parentElement).find('span')[0].innerText = parseInt($.trim($(ele.parentElement).find('span')[0].innerText)) + 1;
    });

}
//列表页添加购物车 ,type判断是哪个列表页 0.三级列表 1.品牌列表 2.会员专享 3.商户列表
function addCart_service(type,sec,id){
        J.Cache.empty('listIndex');
        J.Refresh('#' + sec).destroy();
        var ul = document.getElementById(id);
        var ul_child = ul.getElementsByTagName('li');
        var j;
        for (var i = 0; i < ul_child.length; i++) {
            ul_child[i].index = i;
            ul_child[i].onclick = function () {
                j = this.index;
                J.Cache.save('listIndex',j);
            }
        }
        setTimeout(function () {
            // a序列数 c取十位 b取个位
            var a = J.Cache.get('listIndex').data;
            var b,c;
            if(a > 9){
                b = a%10;
                c = Math.floor(a/10);
            }else{
                b = a;
                c = 0;
            }
            if(type == 0){
                if(J.Cache.get('productList').data.length <=1){
                    var data = J.Cache.get('productList').data[0][a];
                }else{
                    var data = J.Cache.get('productList').data[c][b];
                }
            }else if(type == 1){
                if(J.Cache.get('getProductList').data.length <=1){
                    var data = J.Cache.get('getProductList').data[0][a];
                }else{
                    var data = J.Cache.get('getProductList').data[c][b];
                }
            }else if(type == 2){
                if(J.Cache.get('baiMingDanList').data.length <=1){
                    var data = J.Cache.get('baiMingDanList').data[0][a];
                }else{
                    var data = J.Cache.get('baiMingDanList').data[c][b];
                }
            }else if(type == 3){
                if(J.Cache.get('merchantList').data.length <=1){
                    var data = J.Cache.get('merchantList').data[0][a];
                }else{
                    var data = J.Cache.get('merchantList').data[c][b];
                }
            }
            var specification = [];
            if (data.colorName) {
                var obj = {
                    name: data.colorName,
                    val: data.color.split(","),
                    key: 'colorName'
                };
                specification.push(obj);
            }
            if (data.sizeName) {
                var obj = {
                    name: data.sizeName,
                    val: data.size.split(","),
                    key: 'sizeName'
                };
                specification.push(obj);
            }
            data.specification = specification;
            isHaveSpecification_control(data,sec);
        },10)
}
//常购清单----添加购物车
function fly_service(eventId, goodsScope,sec){
    var oftenBuy = J.Cache.get('oftenBuy').data;
    var mock = {};
    oftenBuy.map(function(item){
        if(item.id == eventId){
            if(item.canBuyNumber != 0){
                if(item.color || item.size){
                    mock.type = 0;
                    mock.color = item.color;
                    mock.size = item.size;
                }else{
                    mock.type = 0;
                    mock.color = '';
                    mock.size = '';
                }
            }else{
                J.showToast('超出可购买数量了哦');
            }
        }
    });
    if(!isEmptyObject(mock)){
        addShoppingCar_service(mock, 0, 1, eventId, goodsScope,sec);
    }
}
//购物车动画起始位置
function createFly(sec){
    $('#' + sec + ' .cartGreen').click(function(event){
        var html = '<div class="flyCart" style="width : 5%"><img src="./img/shopping_cart_green.png" style="width: 100%;" alt=""/></div>';
        var e = event;
        var start = { top: e.clientY - 10, left: e.clientX - 10 };
        var endPoint = $('#' + sec +' .footer_cart')[0].getBoundingClientRect();
        var end = { top: endPoint.top, left: endPoint.left + endPoint.width / 2, width: 20, height: 20 };
        var par = {
            start : start,
            end : end,
            sec : sec,
            el : html
        };
        J.Cache.save('fly',par);
    });
}
//开始动画----购物车飞出
function fly(html,start,end,callback){
    ele =  $(html)[0];
    $(ele).css('z-index','100');
    $(ele).fly({
        start: start,
        end: end,
        onEnd: function () {
            this.destroy();
            callback();
        }
    });
}
/**
 * [addShoppingCar_service 加入购物车]
 * @param {Number} eventId   [shangpinid]
 * @param {Number} num       [购买数量]
 * @param {String} color     [购买color]
 * @param {String} size      [购买size]
 * @param {String} reservationTime [预约时间]
 * @param {Number} hanleType [directBuy操作类型 0.加入购物车 1.立即购买]
 */
function addShoppingCar_service(mock, hanleType, num, eventId, goodsScope,sec) {
    var url = 'ws/shoppingAction' + versionMessage.version + '!addShoppingCar.sy';
    var par = {
        serviceEventId: eventId,
        num: num*1,
        directBuy: hanleType
    };
    // mock.type  0.商品 1.服务预约
    if (mock.type == 0) {
        par.color = mock.color;
        par.size = mock.size;
    }
    if (mock.type == 1) {
        par.reservationTime = mock.reservationTime;
    }

//  if(!J.Cache.get('login')) {
////  	offlineShopCar_control(par);
//  	J.showToast('您尚未登录');
//  	J.Router.goTo('#login_section');
//  	return;
//  }
//  //level 0:普通用户 1：白名单用户 2：黑名单A级 3：黑名单B级
//  if (J.Cache.get('login').data.level == 2) {
//      J.showToast('此商品无法添加');
//      return;
//  }
    //白名单商品购买权限
    if (goodsScope == 1) {
        if (J.Cache.get('login')) {
            if (J.Cache.get('login').data.level != 1) {
                J.showToast('此商品为会员专享商品');
                J.Router.goTo('#help_section');
                return;
            }
        }
    }
	if(!J.Cache.get('login')) {
		if(hanleType == 1) {
			J.showToast('您还没有登录');
			return;
		}
		par.unloginId = getUnloginId();
	}
    service.get(url, par, function (data) {
        switch (hanleType) {
            case 0:
                if(sec){
                    var start = J.Cache.get('fly').data.start;
                    var end = J.Cache.get('fly').data.end;
                    var html = J.Cache.get('fly').data.el;
                    fly(html,start,end,function(){
                        setTimeout(function(){
                            cartNum_service(J.Cache.get('fly').data.sec);
                        },10);
                    });
                }
                if(!J.Cache.get('login')) {                	
                	saveOfflineShopCar(data.shoppingCarId);
                }
                J.showToast("添加成功!");
                break;
            case 1:
                var shoppingCarIds = [];
                shoppingCarIds.push(data.shoppingCarId);
                pay.par.shoppingCarIds = JSON.stringify(shoppingCarIds);
                pay.par.deliveryTId = '';
                pay.par.deliveryTime = '';
                pay.clearAccount(1, data.type); //结算fn   
                break;
        }
        if (mock.type == 1) J.Cache.empty('reservation');
    },function(data){
        if(data){
            J.showToast(data.message);
        }
    });
}

// 获取服务预约
function getReservation_service(eventId, times, continueTime, years) {
    var url = 'ws/serviceAction' + versionMessage.version + '!getReservation.sy';
    var par = {
        serviceEventId: eventId,
        time: times
    };
    service.get(url, par, function (data) {
        var mock = {
            date: getFiveDate(),
            time: [],
            id: eventId,
            continueTime: continueTime
        }
        // 将数字转换成时间
        for (var k in data) {
            var h = k.length < 3 ? k.slice(0, 1) : k.slice(0, 2);
            var m = (k.length < 3 ? (k.slice(1) == 1 ? '00' : 30) : (k.slice(2) == 1 ? '00' : 30));
            var timeData = {
                time: h + ':' + m,
                num: data[k],
                timeId: par.time.split('-').join('') + k,
                dateTime: par.time + ' ' + h + ':' + m
            }

            mock.time.push(timeData);
        }
        getReservation_tpl_control(mock, years);
    })
}

// 判断是否能预约
function isAbleReserve_service(eventId, reservationTime, num) {
    var url = 'ws/shoppingAction' + versionMessage.version + '!isAbleReserve.sy';
    var par = {
        serviceEventId: eventId,
        reservationTime: reservationTime
    }
    service.get(url, par, function (data) {
        var mock = {
            type: 1,
            reservationTime: reservationTime
        }
        if(num < 0) {
			num = num * -1;
		}	
        addShoppingCar_service(mock, 1, num, eventId);
    })
}

// 分享后成功回调
function shareContent_service() {
    var url = 'ws/othersAction' + versionMessage.version + '!shareContent.sy';
    var par = {};
    service.get(url, par, function (data) {

    })
}